package js

import (
	"embed"
	"io/fs"
)
import _ "embed"

//go:embed *.js
var indexList embed.FS

//go:embed */*.js
var jsList embed.FS

//go:embed event/impl/*
var eventImplJs embed.FS

var jsMap = initJsMap()

func initJsMap() map[string][]byte {

	var dataMap = make(map[string][]byte)
	//index.js
	btData, _ := indexList.ReadFile("index.js")
	dataMap["index.js"] = btData

	//eventImpl
	list, err := eventImplJs.ReadDir("event/impl")
	if err != nil {
		panic(err)
		return nil
	}
	if list != nil && len(list) > 0 {
		for _, file := range list {
			//读取配置文件
			data, err := eventImplJs.ReadFile("event/impl/" + file.Name())
			if err == nil {
				dataMap["event/impl/"+file.Name()] = data
			}
		}
	}

	list = initJsMapInner("lib")
	if list != nil && len(list) > 0 {
		for _, file := range list {
			//读取配置文件
			data, err := jsList.ReadFile("lib/" + file.Name())
			if err == nil {
				dataMap["lib/"+file.Name()] = data
			}
		}
	}

	list = initJsMapInner("common")
	if list != nil && len(list) > 0 {
		for _, file := range list {
			//读取配置文件
			data, err := jsList.ReadFile("common/" + file.Name())
			if err == nil {
				dataMap["common/"+file.Name()] = data
			}
		}
	}

	list = initJsMapInner("event")
	if list != nil && len(list) > 0 {
		for _, file := range list {
			//读取配置文件
			data, err := jsList.ReadFile("event/" + file.Name())
			if err == nil {
				dataMap["event/"+file.Name()] = data
			}
		}
	}

	return dataMap
}

func initJsMapInner(path string) []fs.DirEntry {
	list, err := jsList.ReadDir(path)
	if err != nil {
		panic(err)
		return nil
	}

	return list
}
